//+------------------------------------------------------------------+
//|                                                      2012_rs.mq4 |
//|                                   Copyright  2011, Icy software |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Icy software"
#property link      ""

static string   indicatorName = "2014_ma20_4gban"; 

#property indicator_chart_window

 #property indicator_buffers 8
#property indicator_color1 LightSeaGreen
#property indicator_color2 LightSeaGreen

#property indicator_color3 PowderBlue
#property indicator_width3 2

#property indicator_color4 Orange
#property indicator_color5 Orange
 

#property indicator_color6 Violet
#property indicator_color7 Violet

   extern double myband = 10;


double ma20a[], ma20b[], ma20[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   /*SetIndexShift(0,10);
   SetIndexShift(1,10);
   SetIndexShift(2,10);
   SetIndexShift(3,10);
   SetIndexShift(4,10);
   
   SetIndexShift(5,10);
   SetIndexShift(6,10);   
*/
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ma20a);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ma20b);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ma20);   
  
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//----
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   int i=limit;
   //showme0 ("1",  trendname, 1, 10, Lime,  10, 0, 1, "Arial");

   while (i>=0) {
   
        ma20[i] = iMA(NULL,0,20,0,MODE_SMA,PRICE_CLOSE,i);
        ma20a[i] = ma20[i] + myband;
        ma20b[i] = ma20[i] - myband;
        
        
   
   i--;   
   }


//----
   return(0);
  }
//+------------------------------------------------------------------+
void drawTangle(string index, datetime t1, datetime t2,double p1, double p2, color clor, double angle) {
   ObjectDelete(indicatorName + index);  
   ObjectCreate(indicatorName + index,OBJ_TRENDBYANGLE ,0,t1,p1,t2,p2 );  
   

   ObjectSet(indicatorName + index, OBJPROP_ANGLE, angle);
   ObjectSet(indicatorName + index, OBJPROP_COLOR, clor);
   ObjectSet(indicatorName + index, OBJPROP_WIDTH, 1);
   ObjectMove(indicatorName + index, 0, t1, (p2)-(p1-p2));
   
      double pp1 = ObjectGet(indicatorName + index, OBJPROP_PRICE1);
      double pp2 = ObjectGet(indicatorName + index, OBJPROP_PRICE2);
      datetime tt1 = ObjectGet(indicatorName + index, OBJPROP_TIME1);
      datetime tt2 = ObjectGet(indicatorName + index, OBJPROP_TIME2);
      
drawTrendx(index+"", tt1, t2,  pp1,   p2 , clor, 2, 1) ;
      
      //showme0 ("2",  pp2, 1, 25, Lime,  10, 0, 1, "Arial");
      //showme0 ("3",  tt2, 1, 40, Lime,  10, 0, 1, "Arial");      
         
 
}

void drawTrendx(string index, datetime t1, datetime t2,  double y1,  double y2, color mycolor, int mywidth, int mystyle) {

ObjectDelete(indicatorName + index);         
ObjectCreate(indicatorName + index,OBJ_TREND, 0,  t1, y1,t2,y2 ); 
//ObjectSetText(indicatorName + index, stext, myfontsize, myfont, mycolor);
ObjectSet(indicatorName + index,OBJPROP_RAY,true);
ObjectSet(indicatorName + index,OBJPROP_WIDTH,mywidth);
ObjectSet(indicatorName + index,OBJPROP_STYLE,mystyle);
ObjectSet(indicatorName + index,OBJPROP_COLOR,mycolor);



}
void showme0 (string index, string text, int x, int y, color mycolor,  int myfontsize, double myangle, int xconner, string myfont) {


ObjectDelete(indicatorName  + index);   
   ObjectCreate(indicatorName   + index, OBJ_LABEL, 0 , 0, 0);
   //ObjectSetText(indicatorName  + indicatorName + index,text,myfontsize, "Verdana", mycolor);
   ObjectSetText(indicatorName   + index,text,myfontsize, myfont, mycolor);
   ObjectSet(indicatorName   + index, OBJPROP_CORNER, xconner);
   ObjectSet(indicatorName   + index, OBJPROP_XDISTANCE, x);
   ObjectSet(indicatorName   + index, OBJPROP_YDISTANCE, y);
   ObjectSet(indicatorName  + index, OBJPROP_ANGLE , 0);
  //ObjectSet(indicatorName + index, OBJPROP_BACK, 0);
  //ObjectSet(indicatorName + index,OBJPROP_RAY,true);
}

string find_bartime_min(int xbar) {

        return( TimeToStr(Time[xbar],TIME_MINUTES    ) );
        
}
string find_bartime_period_min(int period, int xbar) {

        return( TimeToStr(iTime(NULL,period,xbar),TIME_MINUTES    ) );
        
}

string find_bardate(int xbar) {

        return( TimeToStr(Time[xbar],TIME_DATE    ) );
}

string find_bardate2(int p, int xbar) {

        return( TimeToStr(iTime(NULL,p,xbar),TIME_DATE    ) );
}

void drawLineH(string index, datetime t1,  double y1, color mycolor, int mystyle, int mywidth, int myback) {

ObjectDelete(indicatorName + index);         
ObjectCreate(indicatorName + index,OBJ_HLINE, 0,  t1, y1 ); 
ObjectSet(indicatorName + index,OBJPROP_COLOR,mycolor);
ObjectSet(indicatorName + index,OBJPROP_WIDTH,mywidth);
ObjectSet(indicatorName + index,OBJPROP_STYLE,mystyle);
ObjectSet(indicatorName + index,OBJPROP_RAY,true);

ObjectSet(indicatorName + index,OBJPROP_BACK, myback);

}